//	+---------------------------+
//	|	Text to Speech			|
//	+---------------------------+
//	|	Version: 1.0			|
//	|	Released: Apr 15, 2014	|
//	|	Author: Zapk | 12270	|
//	+---------------------------+
if(!isObject(TextToSpeechALX))
{
	new AudioDescription(TextToSpeechALX)
	{
		is3D = false;
		isLooping = false;
		loopCount = 0;
		type = 8;
		volume = 1;
	};
}
TextToSpeechALX.volume = 14;

if(isPackage(TextToSpeech))
{
	deactivatePackage(TextToSpeech);
}

package TextToSpeech
{
	function clientCmdChatMessage(%a, %b, %c, %fmsg, %cp, %name, %cs, %msg)
	{
		doTextToSpeech(%msg);
		Parent::clientCmdChatMessage(%a, %b, %c, %fmsg, %cp, %name, %cs, %msg);
	}
};

activatePackage(TextToSpeech);

function doTextToSpeech(%msg)
{
	%this = new TCPObject(TextToSpeechConnection)
	{
		ttsText = %msg;
		ttsFile = "";
	};
	%this.connect("speechutil.com:80");
}

function TextToSpeechConnection::onConnected(%this)
{
	%this.send("GET /convert/ogg?text=" @ urlEnc(%this.ttsText) @ " HTTP/1.1\r\nHost: speechutil.com \r\n\r\n");
	echo(urlEnc(%this.ttsText));
}

function TextToSpeechConnection::onLine(%this,%line)
{
	echo(%line);
	if(strPos(%line, "Content-Length:") >= 0)
	{
		%this.contentSize = getWord(%line, 1);
		echo("\c4lol" @ %this.contentSize);
	}
		
	if(%line $= "")
		%this.setBinarySize(%this.contentSize);
}

function TextToSpeechConnection::onBinChunk(%this, %chunk)
{
	echo(%chunk);
	if(%chunk >= %this.contentSize)
	{
		%this.ttsFile = "base/client/tts/" @ sha1(%this.ttsText) @ ".ogg";
		%this.saveBufferToFile(%this.ttsFile);
		
		%this.schedule(33,doSound);
	}
}

function TextToSpeechConnection::doSound(%this)
{
	if(isFile(%this.ttsFile))
	{
		alxPlay( alxCreateSource(TextToSpeechALX, %this.ttsFile) );
	}
	echo(%this.ttsFile);
	echo(isFile(%this.ttsFile));
	
	%this.delete();
}